/* - main.js - */
/********* Re-trans script *************/
/*
 * Custom JS for Re-trans customization of Poi
 */


$(function() {
    function handleRange(key) {
        var start_id = "#" + key + "_start";
        var end_id = "#" + key + "_end";
        var range_id = "#" + key + "_range";
        var start = $(start_id).val();
        var end = $(end_id).val();
        var range_obj = $(range_id);
        if (start && end) {
            range_obj.val("min:max");
        }
        if (start && !end) {
            range_obj.val("min");
        }
        if (!start && end) {
            range_obj.val("max");
        }
        if (!start && !end) {
            range_obj.val("");
        }
    }

    // set up the datepickers
    $.datepicker.setDefaults( $.datepicker.regional[ "" ] );
    $(".datepicker").datepicker({
        changeMonth: true,
        changeYear: true
    });

    // handle date changes
    $(".datepicker").on("change", function() {
        var key = $(this).data("key");
        handleRange(key);
    });

    // run on page load in case some dates are prefilled by browser
    handleRange("submitted");
    handleRange("modified");
    handleRange("requested_by");

    // add totals to tracker search links
    if ($(".template-poi_tracker_view").length) {
        var link_lists = $(".tracker-info");

        function populateTotals(data) {
            link_lists.each(function() {
                list = $(this);
                key = list.data("key");
                items = data[key];
                $(items).each(function(i){
                    if (items[i]['key']) {
                        list.find("a[data-key='"+ items[i]['key'] +"']").after(
                            " <span class='info-total'>(" + items[i]['total'] + ")</span>"
                        );
                    }
                })
            })

        }

        $.ajax({
            url: $("body").data("view-url") + "/tracker_json_info",
            success: function(data) {
                populateTotals(data)
            }
        })
    }

    // create gitlab issue
    if ($("#create-gitlab-issue").length) {
        var button = $("#create-gitlab-issue");
        button.on("click", function(e) {
            e.preventDefault();
            if (!$(this).hasClass('done')) {
                orig_text = button.text();
                button.text("Creating GitLab Issue…");
                $(this).blur();
                $.ajax({
                    url: $("body").data("view-url") + "/create_gitlab_issue",
                    success: function(data) {
                        button.removeClass("error");
                        button.addClass("done");
                        button.text("Created GitLab Issue");
                    },
                    error: function(jqxhr, status, error) {
                        button.removeClass("done");
                        button.addClass("error");
                        button.text(orig_text);
                        alert(error);
                    }
                })
            }
        })
    }
});
